unit ICCheckboxWhats;

interface

	uses
		ICWindowGlobals;

	function WhatOpenCheckbox (wt: WindowType; item: integer): OSErr;
	function WhatFlushCheckbox (wt: WindowType; item: integer): OSErr;
	function WhatClickCheckbox (wt: WindowType; item: integer; er: eventRecord): OSErr;

implementation

	uses
		ICAPI,
		ICSubs,
		ICDialogs,
		ICDocument;

	function WhatOpenCheckbox (wt: WindowType; item: integer): OSErr;
		var
			tmp_data : SInt8;
			attr : ICAttr;
			size : longint;
	begin
		size := sizeof(tmp_data);
		if ICGetPref(GetInstance, windowinfo[wt].items[item]^.key, attr, @tmp_data, size) <> noErr then begin
			tmp_data := 0;
		end; (* if *)
		tmp_data := band(tmp_data, 1);
		ProcessAttributes(wt, item, attr);
		SetDCtlValue(windowinfo[wt].window, item, tmp_data);
		WhatOpenCheckbox := noErr;
	end; (* WhatOpenCheckbox *)
	
	function WhatFlushCheckbox (wt: WindowType; item: integer): OSErr;
		var
			err : OSErr;
			tmp_data : SInt8;
	begin
		tmp_data := band(GetDCtlValue(windowinfo[wt].window, item), 1);
		err := ICMapErr(ICSetPref(GetInstance, windowinfo[wt].items[item]^.key, ICattr_no_change, @tmp_data, 1));
		WhatFlushCheckbox := err;
	end; (* WhatFlushCheckbox *)
	
	function WhatClickCheckbox (wt: WindowType; item: integer; er: eventRecord): OSErr;
	begin
		{$unused er}
		if not IsLocked(wt, item) then begin
			ToggleDCtlBoolean(windowinfo[wt].window, item);
			DirtyDocument;
		end else begin
			LockedAlert(wt, item);
		end; (* if *)
		WhatClickCheckbox := noErr;
	end; (* WhatClickCheckbox *)

end. (* ICCheckboxWhats *)