unit ICSoundPopupWhats;

interface

	uses
		ICWindowGlobals;

	function WhatOpenSoundPopup (wt: WindowType; item: integer): OSErr;
	function WhatFlushSoundPopup (wt: WindowType; item: integer): OSErr;
	function WhatClickSoundPopup (wt: WindowType; item: integer; er: eventRecord): OSErr;

implementation

	uses
		TextUtils,
		Sound,
		Resources,
		
		ICAPI,
		ICSubs,
		ICDialogs,
		ICDocument,
		ICMiscSubs,
		ICGlobals;

	function WhatOpenSoundPopup (wt: WindowType; item: integer): OSErr;
		var
			menuh : MenuHandle;
			menu_index : integer;
			preference_found_in_menu : Boolean;
			current_sound_name : Str255;
			attr : ICAttr;
			menu_count : integer;
			item_text : Str255;
	begin
		menuh := GetPopupMHandle(windowinfo[wt].window, item);
		
		(* Get the current value.  If we can't get it, use the first item from the menu as a default. *)
		if ICGetPrefStr (GetInstance, windowinfo[wt].items[item]^.key, attr, current_sound_name) <> noErr then begin
			GetMenuItemText(menuh, 1, current_sound_name);
		end; (* if *)
		ProcessAttributes(wt, item, attr);

		(* Find the current value in the menu. *)
		preference_found_in_menu := false;
		menu_count :=  CountMItems(menuh);
		menu_index := 1;
		while not preference_found_in_menu and (menu_index <= menu_count) do begin
			GetMenuItemText(menuh, menu_index, item_text);
			if IUCompString(item_text, current_sound_name) = 0 then begin
				preference_found_in_menu := true;
			end else begin
				menu_index := menu_index + 1;
			end; (* if *)
		end; (* for *)
		
		(* If it's not there, add it at the end. *)
		if not preference_found_in_menu then begin
			AppendMenu(menuh, '(-');
			SafeAppendMenu(menuh, current_sound_name);
			menu_index := CountMItems(menuh);
			SetControlMaximum(GetDControlHandle(windowinfo[wt].window, item), menu_index);
		end; (* if *)

		(* Prepare the control. *)
		SetDCtlValue(windowinfo[wt].window, item, menu_index);
		SetDCtlEnable(windowinfo[wt].window, item, not IsLocked(wt, item));
		
		WhatOpenSoundPopup := noErr;
	end; (* WhatOpenSoundPopup *)
	
	function GetNameOfCurrentSound(wt: WindowType; item: integer) : Str255;
		var
			dlg : DialogPtr;
			current_control_value : integer;
			current_sound_name : Str255;
	begin
		dlg := windowinfo[wt].window;
		current_control_value := GetDCtlValue(dlg, item);
		GetMenuItemText(GetPopupMHandle(dlg, item), current_control_value, current_sound_name);
		GetNameOfCurrentSound := current_sound_name;
	end; (* GetNameOfCurrentSound *)
	
	function WhatFlushSoundPopup (wt: WindowType; item: integer): OSErr;
		var
			err : OSErr;
			current_sound_name : Str255;
	begin
		current_sound_name := GetNameOfCurrentSound(wt, item);
		err := ICMapErr(ICSetPrefStr(GetInstance, windowinfo[wt].items[item]^.key, ICattr_no_change, current_sound_name));
		WhatFlushSoundPopup := err;
	end; (* WhatFlushSoundPopup *)
	
	function WhatClickSoundPopup (wt: WindowType; item: integer; er: eventRecord): OSErr;
		var
			err : OSErr;
			current_sound : SndListHandle;
			junk_long : longint;
	begin
		{$unused er}
		err := noErr;
		if not IsKeyDown (kOptionKeyCode) then begin
			current_sound := SndListHandle(GetNamedResource('snd ', GetNameOfCurrentSound(wt, item)));
			if current_sound <> nil then begin
				err := SndPlay(nil, current_sound, false);
			end else begin
				FlashMenuBar(0);
				Delay(6, junk_long);
				FlashMenuBar(0);
			end; (* if *)
		end; (* if *)

		DirtyDocument;
		WhatClickSoundPopup := err;
	end; (* WhatClickSoundPopup *)
	
end. (* ICSoundPopupWhats *)